"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var documents_1 = require("../server/documents");
var util_1 = require("../common/util");
var workspaces_1 = require("../server/workspaces");
exports.definitionProvider = function (params) {
    var textDocument = params.textDocument, position = params.position;
    var doc = documents_1.documents.get(textDocument.uri);
    if (!doc) {
        return null;
    }
    var words = util_1.getWordFromPosition(doc, position);
    if (!words) {
        return null;
    }
    var currentName = words.word;
    if (/\./.test(words.right)) {
        var tail = words.right.replace(/^[^.]*(\.)/, '$1');
        currentName = words.word.replace(tail, '');
    }
    return workspaces_1.workspace.getLocations(currentName, doc.uri, position, 'definition').locations;
};
//# sourceMappingURL=definition.js.map