"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var vscode_languageserver_1 = require("vscode-languageserver");
var builtin_1 = require("../server/builtin");
var patterns_1 = require("../common/patterns");
var documents_1 = require("../server/documents");
exports.signatureHelpProvider = function (params) {
    var textDocument = params.textDocument, position = params.position;
    var doc = documents_1.documents.get(textDocument.uri);
    if (!doc) {
        return;
    }
    var currentLine = doc.getText(vscode_languageserver_1.Range.create(vscode_languageserver_1.Position.create(position.line, 0), vscode_languageserver_1.Position.create(position.line + 1, 0)));
    // comment line
    if (patterns_1.commentPattern.test(currentLine)) {
        return;
    }
    var preSegment = currentLine.slice(0, position.character);
    var m = preSegment.match(/([\w#&:]+)[ \t]*\(([^()]*|\([^)]*\))*$/);
    if (!m) {
        return;
    }
    var functionName = m['1'];
    var placeIdx = m[0].split(',').length - 1;
    return builtin_1.builtinDocs.getSignatureHelpByName(functionName, placeIdx);
};
//# sourceMappingURL=signatureHelp.js.map