"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var vscode_languageserver_1 = require("vscode-languageserver");
var util_1 = require("../common/util");
exports.commandSnippets = [
    {
        label: 'function',
        kind: vscode_languageserver_1.CompletionItemKind.Snippet,
        insertText: [
            'function ${1:Name}(${2}) ${3:abort}',
            '\t${0}',
            'endfunction'
        ].join('\n'),
        insertTextFormat: vscode_languageserver_1.InsertTextFormat.Snippet
    },
    {
        label: 'trycatch',
        kind: vscode_languageserver_1.CompletionItemKind.Snippet,
        insertText: [
            'try',
            '\t${1}',
            'catch /.*/',
            '\t${0}',
            'endtry'
        ].join('\n'),
        insertTextFormat: vscode_languageserver_1.InsertTextFormat.Snippet
    },
    {
        label: 'tryfinally',
        kind: vscode_languageserver_1.CompletionItemKind.Snippet,
        insertText: [
            'try',
            '\t${1}',
            'finally',
            '\t${0}',
            'endtry'
        ].join('\n'),
        insertTextFormat: vscode_languageserver_1.InsertTextFormat.Snippet
    },
    {
        label: 'trycatchfinally',
        kind: vscode_languageserver_1.CompletionItemKind.Snippet,
        insertText: [
            'try',
            '\t${1}',
            'catch /.*/',
            '\t${2}',
            'finally',
            '\t${0}',
            'endtry'
        ].join('\n'),
        insertTextFormat: vscode_languageserver_1.InsertTextFormat.Snippet
    },
    {
        label: 'augroup',
        kind: vscode_languageserver_1.CompletionItemKind.Snippet,
        insertText: [
            'augroup ${1:Start}',
            '\tautocmd!',
            '\t${0}',
            'augroup END'
        ].join('\n'),
        insertTextFormat: vscode_languageserver_1.InsertTextFormat.Snippet
    },
    {
        label: 'autocmd',
        kind: vscode_languageserver_1.CompletionItemKind.Snippet,
        insertText: [
            "autocmd ${1:group} ${2:event} ${3:pat} ${4:once} ${5:nested} ${6:cmd}"
        ].join('\n'),
        insertTextFormat: vscode_languageserver_1.InsertTextFormat.Snippet
    },
    {
        label: 'if',
        kind: vscode_languageserver_1.CompletionItemKind.Snippet,
        insertText: [
            "if ${1:condition}",
            "\t${0}",
            "endif"
        ].join('\n'),
        insertTextFormat: vscode_languageserver_1.InsertTextFormat.Snippet
    },
    {
        label: 'command',
        kind: vscode_languageserver_1.CompletionItemKind.Snippet,
        insertText: [
            "command! ${1:attr} ${2:cmd} ${3:rep} ${0}",
        ].join('\n'),
        insertTextFormat: vscode_languageserver_1.InsertTextFormat.Snippet
    },
    {
        label: 'highlight',
        kind: vscode_languageserver_1.CompletionItemKind.Snippet,
        insertText: [
            "highlight ${1:default} ${2:group-name} ${3:key}=${4:arg} ${0}",
        ].join('\n'),
        insertTextFormat: vscode_languageserver_1.InsertTextFormat.Snippet
    }
].map(function (item) { return (tslib_1.__assign({}, item, { documentation: util_1.markupSnippets(item.insertText) })); });
//# sourceMappingURL=snippets.js.map